// SPDX-License-Identifier: GPL-2.0-only
/*
 * Copyright (c) 2020-2021, The Linux Foundation. All rights reserved.
 */

#include <linux/types.h>
#include "besbev-registers.h"

const u8 besbev_reg_access_analog[BESBEV_REG(
			BESBEV_ANALOG_REGISTERS_MAX_SIZE)] = {
	[BESBEV_REG(BESBEV_ANA_MICBIAS_MICB_1_2_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_MICBIAS_LDO_1_SETTING)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_MICB_LDO_1_CTRL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_MICB_LDO_ATEST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_AMIC1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_AMIC2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_ATEST_TOP_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_ATEST_BLK_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_TEST_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_TEST_BLK_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_CKIN_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_BIAS_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_TEST_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_TXFE_CLKDIV)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_SAR1_ERR)] = RD_REG,
	[BESBEV_REG(BESBEV_ANA_TX_SAR2_ERR)] = RD_REG,
	[BESBEV_REG(BESBEV_ANA_TX_CTUNE_BYP)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_RCTUNE_OUT)] = RD_REG,
	[BESBEV_REG(BESBEV_ANA_TX_RCTUNE_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_ADC_VREF_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_MISC_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_ANA_TX_SPARE)] = RD_REG,
	[BESBEV_REG(BESBEV_ANA_MBIAS_TSADC_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_SPARE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_OP_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_IREF_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_ISENS_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_CLK_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_TEST_CTL_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_BIAS_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_ADC_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_VBAT_SNS)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_DOUT_MSB)] = RD_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_DOUT_LSB)] = RD_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_BOP_UVLO_PROG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_ADC_ITRIM_PROG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_BOP_HYST_PROG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_MBIAS_TSADC_BOP_ATEST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_DAC_CTRL_REG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_DAC_EN_DEBUG_REG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_DAC_REFBUF_CTRL_REG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_ATEST_REG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_TOP_BIAS_REG1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_TOP_BIAS_REG2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_TOP_BIAS_REG3)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_TOP_BIAS_REG4)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_CLIP_DET_REG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_LF_BLK_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_LF_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_LF_MISC_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_LF_MISC_CTL1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_LF_REG_GAIN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_OS_CAL_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_DRV_OS_CAL_CTL1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_PWM_CLK_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_PDRV_HS_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_PDRV_LS_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_PWRSTG_DBG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPKR_OCP_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPKR_BBM_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_PA_STATUS0)] = RD_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_PA_STATUS1)] = RD_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_PA_STATUS2)] = RD_REG,
	[BESBEV_REG(BESBEV_SPK_TOP_SPARE)] = RD_REG,
	[BESBEV_REG(BESBEV_CKWD_CKWD_CTL_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CKWD_CKWD_CTL_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CKWD_CKWD_CTL_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CKWD_ADTEST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CKWD_STATUS)] = RD_REG,
	[BESBEV_REG(BESBEV_CKWD_SPARE)] = RD_REG,
	[BESBEV_REG(BESBEV_IVSENSE_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_OVERRIDE1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_OVERRIDE2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_VSENSE1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ISENSE1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ISENSE2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ISENSE_CAL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_MISC)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_3)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_4)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_5)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_6)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_ADC_7)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_STATUS)] = RD_REG,
	[BESBEV_REG(BESBEV_IVSENSE_CALREF_CALICODE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_IDLE_CTRL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_IVSENSE_SPARE_STATUS)] = RD_REG,
};

const u8 besbev_reg_access_digital[BESBEV_REG(
			BESBEV_DIGITAL_REGISTERS_MAX_SIZE)] = {
	[BESBEV_REG(BESBEV_DIG_SWR_CHIP_ID0)] = RD_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CHIP_ID1)] = RD_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CHIP_ID2)] = RD_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CHIP_ID3)] = RD_REG,
	[BESBEV_REG(BESBEV_SPKR_OCP_CTL)] = RD_WR_REG,
/*	[BESBEV_REG(BESBEV_CHIP_ID0)] = RD_REG, */
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_RST_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_RST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_RX_RST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_TX_RST)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_RST_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CLK_CFG)] = RD_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_TX_CLK_RATE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_RX_MODE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_CDC_TX_MODE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_RX_CLK_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_SWR_TX_CLK_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_TIMER0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_TIMER1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_STA)] = RD_REG,
	[BESBEV_REG(BESBEV_PA_FSM_ERR_COND)] = RD_REG,
	[BESBEV_REG(BESBEV_PA_FSM_MSK)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_BYP)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_FSM_DBG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_OTP_LOW_M)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_OTP_LOW_L)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_OTP_HIGH_M)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PA_OTP_HIGH_L)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TADC_VALUE_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TEMP_DETECT_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TEMP_MSB)] = RD_REG,
	[BESBEV_REG(BESBEV_TEMP_LSB)] = RD_REG,
	[BESBEV_REG(BESBEV_TEMP_CONFIG0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TEMP_CONFIG1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VBAT_ADC_FLT_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VBAT_DIN_MSB)] = RD_REG,
	[BESBEV_REG(BESBEV_VBAT_DIN_LSB)] = RD_REG,
	[BESBEV_REG(BESBEV_VBAT_DOUT)] = RD_REG,
	[BESBEV_REG(BESBEV_SDM_PDM9_LSB)] = RD_REG,
	[BESBEV_REG(BESBEV_SDM_PDM9_MSB)] = RD_REG,
	[BESBEV_REG(BESBEV_UVLO_DEGLITCH_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_BOP_DEGLITCH_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_RX_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_SPK_GAIN_PDM_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_SPK_GAIN_PDM_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_SPK_GAIN_PDM_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PDM_WD_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DEM_BYPASS_DATA0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DEM_BYPASS_DATA1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DEM_BYPASS_DATA2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DEM_BYPASS_DATA3)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DRE_CTL_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DRE_CTL_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DRE_IDLE_DET_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_GAIN_RAMPING_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TAGC_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TAGC_TIME)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TAGC_E2E_GAIN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TAGC_FORCE_VAL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VAGC_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VAGC_TIME)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VAGC_ATTN_LVL_1_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_VAGC_ATTN_LVL_3)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_MODE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_MASK0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_MASK1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_STATUS0)] = RD_REG,
	[BESBEV_REG(BESBEV_INTR_STATUS1)] = RD_REG,
	[BESBEV_REG(BESBEV_INTR_CLEAR0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_CLEAR1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_LEVEL0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_LEVEL1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_SET0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_SET1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_TEST0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_INTR_TEST1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_PDM_TEST_MODE)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_DEBUG_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_DEBUG_EN)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SWR_HM_TEST0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SWR_HM_TEST1)] = RD_REG,
	[BESBEV_REG(BESBEV_SAMPLE_EDGE_SEL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DATA_EDGE_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SWR_EDGE_SEL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TADC_DETECT_DBG_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TADC_DEBUG_MSB)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TADC_DEBUG_LSB)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SSP_DBG)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_DIG_DEBUG_CSR)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPARE_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPARE_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_SPARE_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_TRIM_NUM)] = RD_REG,
	[BESBEV_REG(BESBEV_CDC_TX0_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_TX1_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_REQ0_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_CDC_REQ1_CTL)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_P5_SPARE_0)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_P5_SPARE_1)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_P5_SPARE_2)] = RD_WR_REG,
	[BESBEV_REG(BESBEV_P5_TRIM_NUM)] = RD_REG,
};
